//+------------------------------------------------------------------+
//|                                           CloseOnNetProfitEA.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern bool CloseOnProfit = true;
extern bool LogHiLowToScreen=true;
extern double  CloseAtOrAboveDollarAmt =  50;
extern double Hi = 0;
extern double Lo = 0;

 int m_intTotOrders =0;
 double m_dblLo = 9999.00;
 double m_dblHi = -9999.00;
 
 double m_dblDollarAmountofOrders =0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  
  m_intTotOrders=OrdersTotal();
  if (Hi != 0) m_dblHi=Hi;
  if (Lo != 0) m_dblLo=Lo ;
  
  Comment("High = " + DoubleToStr(m_dblHi,2) + "   "  + "Low = " + DoubleToStr(m_dblLo,2));
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  Comment("");

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(OrdersTotal() != m_intTotOrders)m_intTotOrders = OrdersTotal();
   for(int pos=0;pos<m_intTotOrders;pos++)
   {
      if(OrderSelect(pos,SELECT_BY_POS)==false) continue;
       
      m_dblDollarAmountofOrders=m_dblDollarAmountofOrders+OrderProfit()+
      OrderCommission()+OrderSwap();
      
   }
   
   //chk if greater than user input
   CheckHiLo();
   CheckCloseOnProfit();
  
   
//----
   return(0);
  }

void CheckHiLo()
  {
  
    if (m_dblDollarAmountofOrders < m_dblLo) m_dblLo=m_dblDollarAmountofOrders ;
    if (m_dblDollarAmountofOrders > m_dblHi) m_dblHi=m_dblDollarAmountofOrders ;
    m_dblDollarAmountofOrders=0;
    
    //chk if user wants to display to screen
    if (LogHiLowToScreen) Comment("High = " + 
    DoubleToStr(m_dblHi,2) + "   "  + "Low = " + 
    DoubleToStr(m_dblLo,2) + "  Profit: " + m_dblDollarAmountofOrders);
    
    
  }  
  
void CheckCloseOnProfit()
{
  if (CloseOnProfit)
  {
    if (m_dblDollarAmountofOrders >= CloseAtOrAboveDollarAmt)
    {
      Comment(m_dblDollarAmountofOrders);
      // close all orders
      for(int i=1; i<=OrdersTotal(); i++)  // begin search orders to Close
      {
        if (OrderSelect(i-1,SELECT_BY_POS)==true)  // check for order
        {
           int Type=OrderType();  //order type
           if (Type>1) continue; // pending order 
           OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3);
                            
        }
      }        
    }
  
  }
}  
  
//+------------------------------------------------------------------+